/**
 	- Eclipse Plug-in Developer Community for Korean -
 	http://cafe.naver.com/eclipseplugin
 	Copyright (C) 2005 Seok-Ho, Yang <seokho.yang@gmail.com>

    This file is part of Eclipse DictionaryView.

    DictionaryView is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    EclipseComics is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with DictionaryView; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
    Linking this library statically or dynamically with other modules is
    making a combined work based on this library.  Thus, the terms and
    conditions of the GNU General Public License cover the whole
    combination.

	As a special exception, the copyright holders of this library give you
	permission to link this library with independent modules to produce an
	executable, regardless of the license terms of these independent
	modules, and to copy and distribute the resulting executable under
	terms of your choice, provided that you also meet, for each linked
	independent module, the terms and conditions of the license of that
	module.  An independent module is a module which is not derived from
	or based on this library.  If you modify this library, you may extend
	this exception to your version of the library, but you are not
	obligated to do so.  If you do not wish to do so, delete this
	exception statement from your version.
*/
package javanese.dictionary.actions;

import javanese.dictionary.views.DictionaryView;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.text.ITextSelection;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IEditorActionDelegate;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.texteditor.ITextEditor;

public class SearchWord implements IEditorActionDelegate, IObjectActionDelegate {

	private ITextEditor textEditor;
	
	public void setActiveEditor(IAction action, IEditorPart targetEditor) {
		if (targetEditor instanceof ITextEditor)
			textEditor = (ITextEditor)targetEditor;
		else
			textEditor = null;
	}

	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
		if (targetPart instanceof ITextEditor)
			textEditor = (ITextEditor)targetPart;
		else
			textEditor = null;
	}

	public void run(IAction action) {
		if (textEditor==null) return;
		ITextSelection textSelection = (ITextSelection)textEditor.getSelectionProvider().getSelection();
		if (textSelection==null || textSelection.getText()==null) return;
		String word = textSelection.getText();
		showDictionay(word, 0);
	}

	public void showDictionay(String word, int dicType) {
		IWorkbenchPage page = textEditor.getSite().getPage();
		try {
			DictionaryView view = (DictionaryView)page.showView("javanese.dictionary.views.DictionaryView");
			view.setDictionaryType(dicType);
			view.setWord(word);
		} catch(PartInitException ex) {
		}
	}
	
	public void selectionChanged(IAction action, ISelection selection) {
	}

}
